## rapidcheck 0~1033

=== CMakeLists.txt ===
add_library(rapidcheck_test_utils
  util/ArbitraryRandom.cpp
  util/GenUtils.cpp
  util/ShrinkableUtils.cpp)

target_link_libraries(rapidcheck_test_utils PUBLIC
  rapidcheck)
target_include_directories(rapidcheck_test_utils PUBLIC
  .)

add_executable(rapidcheck_tests
  AssertionsTests.cpp
  CheckTests.cpp
  ClassifyTests.cpp
  GenTests.cpp
  LogTests.cpp
  MaybeTests.cpp
  RandomTests.cpp
  SeqTests.cpp
  ShowTests.cpp
  ShrinkableTests.cpp
  detail/AnyTests.cpp
  detail/ApplyTupleTests.cpp
  detail/Base64Tests.cpp
  detail/BitStreamTests.cpp
  detail/CaptureTests.cpp
  detail/ConfigurationTests.cpp
  detail/DefaultTestListenerTests.cpp
  detail/FrequencyMapTests.cpp
  detail/ImplicitParamTests.cpp
  detail/LogTestListenerTests.cpp
  detail/MapParserTests.cpp
  detail/MulticastTestListenerTests.cpp
  detail/PropertyTests.cpp
  detail/ReproduceListenerTests.cpp
  detail/ResultsTests.cpp
  detail/SerializationTests/CompactIntegers.cpp
  detail/SerializationTests/CompactRanges.cpp
  detail/SerializationTests/Integers.cpp
  detail/SerializationTests/Misc.cpp
  detail/ShowTypeTests.cpp
  detail/StringSerializationTests.cpp
  detail/TestMetadataTests.cpp
  detail/TestParamsTests.cpp
  detail/TestingTests.cpp
  detail/VariantTests.cpp
  fn/CommonTests.cpp
  gen/BuildTests.cpp
  gen/ChronoTests.cpp
  gen/ContainerTests/Fixed.cpp
  gen/ContainerTests/NonFixed.cpp
  gen/ContainerTests/Unique.cpp
  gen/CreateTests.cpp
  gen/ExecTests.cpp
  gen/MaybeTests.cpp
  gen/NumericTests.cpp
  gen/PredicateTests.cpp
  gen/SelectTests.cpp
  gen/TextTests.cpp
  gen/TransformTests.cpp
  gen/TupleTests.cpp
  gen/detail/ExecRawTests.cpp
  gen/detail/RecipeTests.cpp
  gen/detail/ScaleIntegerTests.cpp
  gen/detail/ShrinkValueIteratorTests.cpp
  main.cpp
  seq/CreateTests.cpp
  seq/OperationsTests.cpp
  seq/SeqIteratorTests.cpp
  seq/TransformTests.cpp
  shrink/ShrinkTests.cpp
  shrinkable/CreateTests.cpp
  shrinkable/OperationsTests.cpp
  shrinkable/TransformTests.cpp
  state/CommandTests.cpp
  state/CommandsTests.cpp
  state/IntegrationTests.cpp
  state/StateTests.cpp
  state/gen/CommandsTests.cpp
  state/gen/ExecCommandsTests.cpp
  )

target_link_libraries(rapidcheck_tests
  rapidcheck
  Catch2::Catch2
  rapidcheck_catch
  rapidcheck_test_utils)
target_include_directories(rapidcheck_tests PRIVATE
  .
  ../src)

add_test(
  NAME rapidcheck_tests
  COMMAND rapidcheck_tests)

=== boost/CMakeLists.txt ===
add_library(rapidcheck_boost INTERFACE)
target_link_libraries(rapidcheck_boost INTERFACE rapidcheck)
target_include_directories(rapidcheck_boost INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# An INTERFACE library does not need to install anything but its headers
# and information on its targets.
install(TARGETS rapidcheck_boost EXPORT rapidcheckConfig)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (RC_ENABLE_TESTS)
  add_subdirectory(test)
endif()

=== classify/CMakeLists.txt ===
add_executable(classify main.cpp)
target_link_libraries(classify rapidcheck)

=== mapparser/CMakeLists.txt ===
add_executable(mapparser main.cpp MapParser.cpp)
target_link_libraries(mapparser rapidcheck)

=== boost/test/CMakeLists.txt ===
add_executable(rapidcheck_boost_tests
  main.cpp
  OptionalTests.cpp
  )

target_link_libraries(rapidcheck_boost_tests
  boost
  rapidcheck_boost
  rapidcheck_catch
  rapidcheck_test_utils
  Catch2::Catch2)

add_test(
  NAME rapidcheck_boost_tests
  COMMAND rapidcheck_boost_tests)

## rapidcheck 0~1033-08b5058

=== debian/changelog ===
rapidcheck (0~1033-08b5058-3) unstable; urgency=medium

  * Install cmake config to per-arch dirs.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 17 Jul 2022 00:33:09 +0200

rapidcheck (0~1033-08b5058-2) unstable; urgency=medium

  * Enable "extras".
  * Add more autopkgtests.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 14 Feb 2022 11:06:02 +0100

rapidcheck (0~1033-08b5058-1) unstable; urgency=medium

  * Initial release (Closes: #1004287)

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 24 Jan 2022 12:07:16 +0100

=== debian/tests/control ===
Test-Command: c++ -Wall -o "$AUTOPKGTEST_TMP"/⁊ debian/tests/reverse.cc -lrapidcheck && "$AUTOPKGTEST_TMP"/⁊
Features: test-name=reverse
Restrictions: allow-stderr
Depends: g++, librapidcheck-dev

# dividingByTenMakesAllNumbersEqual should fail
Test-Command: c++ -Wall -o "$AUTOPKGTEST_TMP"/⁊ examples/boost_test/main.cpp -lrapidcheck && ! "$AUTOPKGTEST_TMP"/⁊
Features: test-name=boost-test
Restrictions: allow-stderr
Depends: g++, librapidcheck-dev, libboost-test-dev

Test-Command: c++ -Wall -o "$AUTOPKGTEST_TMP"/⁊ examples/classify/main.cpp -lrapidcheck && "$AUTOPKGTEST_TMP"/⁊
Features: test-name=classify
Restrictions: allow-stderr
Depends: g++, librapidcheck-dev

Test-Command: c++ -Wall -o "$AUTOPKGTEST_TMP"/⁊ examples/counter/main.cpp -lrapidcheck && "$AUTOPKGTEST_TMP"/⁊
Features: test-name=counter
Restrictions: allow-stderr
Depends: g++, librapidcheck-dev

# dividingByTenMakesAllNumbersEqual should fail
Test-Command: c++ -Wall -o "$AUTOPKGTEST_TMP"/⁊ examples/gtest/main.cpp -lrapidcheck -lgtest -pthread && ! "$AUTOPKGTEST_TMP"/⁊
Features: test-name=gtest
Restrictions: allow-stderr
Depends: g++, librapidcheck-dev, libgtest-dev

Test-Command: cd examples/mapparser && c++ -Wall -o "$AUTOPKGTEST_TMP"/⁊ main.cpp MapParser.cpp -lrapidcheck && "$AUTOPKGTEST_TMP"/⁊
Features: test-name=mapparser
Restrictions: allow-stderr
Depends: g++, librapidcheck-dev

## rapidcheck 0~1048

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(rapidcheck CXX)

# Don't warn about symbol visibility for static libraries with CMake 3.3 and later.
if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()

set(CMAKE_CXX_STANDARD 11)

option(RC_ENABLE_TESTS "Build RapidCheck tests" OFF)
option(RC_ENABLE_EXAMPLES "Build RapidCheck examples" OFF)
option(RC_ENABLE_RTTI "Build RapidCheck with RTTI" ON)

if(MSVC)
  # /bigobj - some object files become very large so we need this
  # /wd4503 - truncation of decorated name, not much we can do about it so
  #           disable it
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /wd4503 /WX")
  # /RTC* is incompatible with /O2 needed for Random.cpp to speed it up
  string(REGEX REPLACE "/RTC(su|[1su])" ""
    CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-missing-braces -Wno-unused-command-line-argument")
  if(APPLE)
    if(CMAKE_CXX_COMPILER_ID MATCHES "^(AppleClang|Clang)")
      # Workaround for legacy Apple environment (cf. https://stackoverflow.com/a/19774902/1682144)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    endif()
  endif()
endif()

# RapidCheck will be built either as a static or a dynamic library depending on the CMake global
# variable BUILD_SHARED_LIBS (https://cmake.org/cmake/help/latest/variable/BUILD_SHARED_LIBS.html).
# If you wish to change the library type of RapidCheck, you can either specify the variable when invoking CMake
# or, if you are including RapidCheck as a subdirectory and wish to control the library type, you can set
# the variable before the call to add_subdirectory and reset it afterwards, if necessary.
add_library(rapidcheck
  src/BeforeMinimalTestCase.cpp
  src/Check.cpp
  src/Classify.cpp
  src/GenerationFailure.cpp
  src/Log.cpp
  src/Random.cpp
  src/Show.cpp
  src/detail/Any.cpp
  src/detail/Assertions.cpp
  src/detail/Base64.cpp
  src/detail/Configuration.cpp
  src/detail/DefaultTestListener.cpp
  src/detail/FrequencyMap.cpp
  src/detail/ImplicitParam.cpp
  src/detail/LogTestListener.cpp
  src/detail/MapParser.cpp
  src/detail/MulticastTestListener.cpp
  src/detail/ParseException.cpp
  src/detail/Platform.cpp
  src/detail/Property.cpp
  src/detail/PropertyContext.cpp
  src/detail/ReproduceListener.cpp
  src/detail/Results.cpp
  src/detail/Serialization.cpp
  src/detail/StringSerialization.cpp
  src/detail/TestMetadata.cpp
  src/detail/TestParams.cpp
  src/detail/Testing.cpp
  src/gen/Numeric.cpp
  src/gen/Text.cpp
  src/gen/detail/ExecHandler.cpp
  src/gen/detail/GenerationHandler.cpp
  src/gen/detail/Recipe.cpp
  src/gen/detail/ScaleInteger.cpp
  )

# Random is used a LOT so it should preferably be really fast.
if(MSVC)
  set_property(SOURCE src/Random.cpp
    APPEND_STRING PROPERTY COMPILE_FLAGS " /O2")
else()
  set_property(SOURCE src/Random.cpp
    APPEND_STRING PROPERTY COMPILE_FLAGS " -O3")
endif()

target_include_directories(rapidcheck PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
    $<INSTALL_INTERFACE:include>  # <prefix>/include
)

include(GNUInstallDirs)
install(TARGETS rapidcheck EXPORT rapidcheckConfig
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} # This is for Windows
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# On Windows under MinGW, random_device provides no entropy,
# so it will always return the same value.
# Seed using system time instead.
# See: https://stackoverflow.com/questions/18880654/why-do-i-get-the-same-sequence-for-every-run-with-stdrandom-device-with-mingw
if(MINGW)
  target_compile_definitions(rapidcheck PRIVATE RC_SEED_SYSTEM_TIME)
endif()

if(NOT RC_ENABLE_RTTI)
  target_compile_definitions(rapidcheck PUBLIC RC_DONT_USE_RTTI)
endif()

add_subdirectory(ext)

if(RC_ENABLE_TESTS)
  enable_testing()
  add_subdirectory(test)
endif()

if(RC_ENABLE_EXAMPLES)
  add_subdirectory(examples)
endif()

add_subdirectory(extras)

# Install the export file specifying all the targets for RapidCheck
install(EXPORT rapidcheckConfig DESTINATION share/rapidcheck/cmake)
export(EXPORT rapidcheckConfig FILE rapidcheckConfig.cmake)

=== boost_test/CMakeLists.txt ===
add_library(rapidcheck_boost_test INTERFACE)
target_link_libraries(rapidcheck_boost_test INTERFACE rapidcheck)
target_include_directories(rapidcheck_boost_test INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# An INTERFACE library does not need to install anything but its headers
# and information on its targets.
install(TARGETS rapidcheck_boost_test EXPORT rapidcheckConfig)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== catch/CMakeLists.txt ===
add_library(rapidcheck_catch INTERFACE)
target_link_libraries(rapidcheck_catch INTERFACE rapidcheck)
target_include_directories(rapidcheck_catch INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# An INTERFACE library does not need to install anything but its headers
# and information on its targets.
install(TARGETS rapidcheck_catch EXPORT rapidcheckConfig)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== counter/CMakeLists.txt ===
add_executable(counter main.cpp)

target_link_libraries(counter rapidcheck)
target_include_directories(counter PRIVATE ../../ext/catch/include)

=== gmock/CMakeLists.txt ===
add_library(rapidcheck_gmock INTERFACE)
target_link_libraries(rapidcheck_gmock INTERFACE rapidcheck)
target_include_directories(rapidcheck_gmock INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# An INTERFACE library does not need to install anything but its headers
# and information on its targets.
install(TARGETS rapidcheck_gmock EXPORT rapidcheckConfig)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (RC_ENABLE_TESTS)
  add_subdirectory(test)
endif()

=== gtest/CMakeLists.txt ===
add_library(rapidcheck_gtest INTERFACE)
target_link_libraries(rapidcheck_gtest INTERFACE rapidcheck)
target_include_directories(rapidcheck_gtest INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# An INTERFACE library does not need to install anything but its headers
# and information on its targets.
install(TARGETS rapidcheck_gtest EXPORT rapidcheckConfig)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== gmock/test/CMakeLists.txt ===
add_executable(rapidcheck_gmock_tests main.cpp)
target_link_libraries(rapidcheck_gmock_tests
  rapidcheck_gmock
  rapidcheck_catch
  Catch2::Catch2
  gmock)
target_include_directories(rapidcheck_gmock_tests PRIVATE 
    ${CMAKE_SOURCE_DIR}/ext/googletest/googletest/include
    ${CMAKE_SOURCE_DIR}/ext/googletest/googlemock/include)

# Prevent collision between Gmock and Catch
target_compile_definitions(rapidcheck_gmock_tests PRIVATE
  CATCH_CONFIG_PREFIX_ALL)

add_test(
  NAME rapidcheck_gmock_tests
  COMMAND rapidcheck_gmock_tests)

## rapidcheck 0~1048-a5724ea

=== debian/changelog ===
rapidcheck (0~1048-a5724ea-1) unstable; urgency=medium

  * New upstream snapshot.
  * Fix FTBFS with gcc-13 (Closes: #1037835)

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 15 Jun 2023 12:39:12 +0200

=== debian/control ===
Source: rapidcheck
Section: devel
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 13),
	cmake,
Standards-Version: 4.6.2
Homepage: https://github.com/emil-e/rapidcheck
Vcs-Browser: https://salsa.debian.org/debian/rapidcheck
Vcs-Git: https://salsa.debian.org/debian/rapidcheck
Rules-Requires-Root: no

Package: librapidcheck-dev
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ framework for property based testing
 RapidCheck is a C++ framework for property based testing inspired by
 QuickCheck and other similar frameworks.  In property based testing,
 you state facts about your code that given certain precondition should
 always be true.  RapidCheck then generates random test data to try and
 find a case for which the property doesn't hold.  If such a case is
 found, RapidCheck tries to find the smallest case (for some definition
 of smallest) for which the property is still false and then displays
 this as a counterexample.  For example, if the input is an integer,
 RapidCheck tries to find the smallest integer for which the property is
 false.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DRC_INSTALL_ALL_EXTRAS=ON
